# -*- coding: utf-8 -*-
"""
Created on Wed Oct 10 15:03:51 2018

@author: user
"""

import pandas as pd
import numpy as np
from scipy.spatial.distance import pdist
from scipy.cluster.hierarchy import linkage, dendrogram
import matplotlib.pyplot as plt

plt.rcParams["font.family"] = "IPAexGothic"
plt.rcParams["font.size"] = 15

#ダウンロード先の絶対パスで指定（フォルダの区切りはスラッシュで指定）
#file = pd.ExcelFile("C:/Users/user/Downloads/python.xlsx")
#または、下記のようにインターネットから直接読み込むことも可能
file = pd.ExcelFile("http://pana4405.u-shizuoka-ken.ac.jp/wp-content/uploads/2018/10/python.xlsx")
data = file.parse("宿泊施設数")
print(data)

#距離計算（ユークリッド距離）
dist = pdist(data.iloc[:, 1:], "euclidean")
#階層的クラスタリング
result = linkage(dist)
#グラフとして描く
plt.subplots(figsize=(10,3))
dendrogram(result, labels=data.iloc[:, 0].tolist(), leaf_rotation=-90, leaf_font_size=15)
plt.show()

#東京だけ仲間はずれのわけは？
data.loc[:, "旅館":].plot.bar(stacked=True)
plt.show()

#距離計算（コサイン類似度）
dist = pdist(data.iloc[:, 1:], "cosine")
#階層的クラスタリング
result = linkage(dist)
#グラフとして描く
plt.subplots(figsize=(10,3))
dendrogram(result, labels=data.iloc[:, 0].tolist(), leaf_rotation=-90, leaf_font_size=15)
plt.show()

#静岡、長野、栃木
fig, axes = plt.subplots(nrows=1, ncols=3, figsize=(15, 5))
data[data.都道府県=="静岡県"].iloc[0, 1:].plot.pie(ax=axes[0], autopct="%.1f%%", title="静岡県")
data[data.都道府県=="長野県"].iloc[0, 1:].plot.pie(ax=axes[1], autopct="%.1f%%", title="長野県")
data[data.都道府県=="栃木県"].iloc[0, 1:].plot.pie(ax=axes[2], autopct="%.1f%%", title="栃木県")
plt.show()

#千葉、沖縄
fig, axes = plt.subplots(nrows=1, ncols=2, figsize=(10, 5))
data[data.都道府県=="千葉県"].iloc[0, 1:].plot.pie(ax=axes[0], autopct="%.1f%%", title="千葉県")
data[data.都道府県=="沖縄県"].iloc[0, 1:].plot.pie(ax=axes[1], autopct="%.1f%%", title="沖縄県")
plt.show()

#東京、大阪
fig, axes = plt.subplots(nrows=1, ncols=2, figsize=(10, 5))
data[data.都道府県=="東京都"].iloc[0, 1:].plot.pie(ax=axes[0], autopct="%.1f%%", title="東京都")
data[data.都道府県=="大阪府"].iloc[0, 1:].plot.pie(ax=axes[1], autopct="%.1f%%", title="大阪府")
plt.show()